#include "io430.h"
#include <stdio.h>

void write(unsigned int a)
{
  unsigned int p = 1;
  for(unsigned int b = a; b >= 10; b /= 10)
  {
    p *= 10;
  }
  for(; p > 0; p /= 10)
  {
    putchar('0' + a/p);
    a %= p;
  }
}

void writeFixedPoint(unsigned int a)
{
  write(a/256); // Professioneller wre a >> 8, aber das >> hatten wir nicht.
  putchar(',');
  for(int i = 0; i < 4; i++)
  {
    a &= 0xff;
    a *= 10;
    putchar('0' + a/256);  
  }
  putchar('\n');
}

unsigned int convertToFixedPoint(float x)
{
  return (int)(256.0f*x);
}

int main(void)
{
  WDTCTL = WDTPW + WDTHOLD;  

  // Man beachte, welche massiven Rundungsfehler dadurch entstehen,
  // dass wir nur acht Bits hinter dem Komma haben!

  unsigned int a = convertToFixedPoint(123.4567f);
  writeFixedPoint(a);
  
  a = convertToFixedPoint(93.7547f);
  writeFixedPoint(a);

  return 0;
}

